#include "top-down-size-splay.hpp"

using namespace SplayTree;

int main(){



  /* A sample use of these functions.  Start with the empty tree,         */
  /* insert some stuff into it, and then delete it                        */

  //Tree<int> * root = NULL;  
  Tree<double> * root = NULL; 
  Tree<double> * t;

  for (unsigned int i = 0; i < 100; i++) 
    //root = insert((541*i) & (1023), root);
    root = insert_node<double>((double)((541*i)&1023), root);
  
  printtree(root, 0);

  for (unsigned int i = 0; i < 100; i++) {
    std::cout << std::endl << "DELETE " << i << std::endl;
    root = delete_node<double>((541*i) & (1023), root);
    printtree(root, 0);
  }

  for (unsigned int i = 0; i < 100; i++) 
    root = insert_node<double>((double)((541*i)&1023), root);
  
  printtree(root, 0);
  
  for (int i = -1; i<=100; i++) {
    t = find_rank(i, root);           // will change it
    if (t == NULL) 
      std::cout << "could not find a node of rank=" << i << std::endl;
    else 
      std::cout << t->key << "is of rank=" << i << std::endl;
  }
  
  printtree(root, 0);
  
  for (unsigned int i=0; i<1000; i=i+20) {
    root = splay<double>(i, root);
    std::cout << "There are " <<  node_size(root->left) 
	      << " elements to the left of " << i << " in the set" << std::endl;
  }
  
  for (unsigned int i = 0; i < 100; i++) {
    root = delete_node<double>((541*i) & (1023), root);
  }
   
};




//
